commit fc9c0563d6f55e01260d7bd7f4c34cd9ff531c5f
Author: Katja Luther <k.luther@bgbm.org>
Date:   Tue Oct 2 11:48:12 2018 +0200

    ref #7063:handle orderedTerms without orderindex and order by lable

diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/e4/ChecklistEditorE4.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/e4/ChecklistEditorE4.java
index fe23adf57..2cff153c1 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/e4/ChecklistEditorE4.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/checklist/e4/ChecklistEditorE4.java
@@ -331,8 +331,9 @@ public class ChecklistEditorE4 implements IPartContentHasFactualData, IConversat
         }
 
 
-        Map<Integer, Boolean> restoreValuesForColumnWidth = restoreValuesForColumnWidth(titles, bounds);
-        createInitalDistributionColumns(table, titles, bounds, restoreValuesForColumnWidth);
+      //  Map<Integer, Boolean> restoreValuesForColumnWidth =
+        restoreValuesForColumnWidth(titles, bounds);
+        createInitalDistributionColumns(table, titles, bounds);
         table.setSortDirection(SWT.DOWN);
         table.setHeaderVisible(true);
         table.setLinesVisible(true);
@@ -349,7 +350,7 @@ public class ChecklistEditorE4 implements IPartContentHasFactualData, IConversat
      * @param restoreValuesForColumnWidth
      */
 	private void createInitalDistributionColumns(Table table,
-			List<String> titles, List<Integer> bounds, Map<Integer, Boolean> restoreValuesForColumnWidth) {
+			List<String> titles, List<Integer> bounds) {
 		for (int columnIndex = 0; columnIndex < titles.size(); columnIndex++) {
             TableViewerColumn column = new TableViewerColumn(viewer, SWT.NONE);
             column.getColumn().setText(titles.get(columnIndex));
@@ -366,11 +367,11 @@ public class ChecklistEditorE4 implements IPartContentHasFactualData, IConversat
             }
             if ((columnIndex == 1 && !PreferencesUtil.isShowRankInChecklistEditor()) || columnIndex >= 2 ) {
                 //read PrefrenceStore to setWidth according to last saved state
-                if(restoreValuesForColumnWidth.get(columnIndex)){
+//                if(restoreValuesForColumnWidth.get(columnIndex)){
                     column.getColumn().setWidth(50);
-                }else{
-                    column.getColumn().setWidth(0);
-                }
+//                }else{
+//                    column.getColumn().setWidth(0);
+//                }
                 column.setEditingSupport(new DistributionEditingSupportE4(viewer, this, columnIndex));
 
             }
@@ -386,9 +387,9 @@ public class ChecklistEditorE4 implements IPartContentHasFactualData, IConversat
      * @param bounds
      * @return Map<Integer, Boolean>
      */
-	private Map<Integer, Boolean> restoreValuesForColumnWidth(List<String> titles,
+	private void restoreValuesForColumnWidth(List<String> titles,
 			List<Integer> bounds) {
-		Map<Integer, Boolean> restoreColumnWidth = new HashMap<Integer, Boolean>();
+//		Map<Integer, Boolean> restoreColumnWidth = new HashMap<Integer, Boolean>();
 		if (labelProvider.getNamedAreas(true) != null) {
 		    int columnIndex;
 		    if (PreferencesUtil.isShowRankInChecklistEditor()){
@@ -398,7 +399,7 @@ public class ChecklistEditorE4 implements IPartContentHasFactualData, IConversat
 		    }
             for (DefinedTermBase<DefinedTermBase> term : getLabelProvider().getNamedAreas(false)) {
                 if(term != null){
-                    restoreColumnWidth.put(columnIndex, PreferencesUtil.getPreferenceStore().getBoolean(term.getUuid().toString()));
+                   // restoreColumnWidth.put(columnIndex, PreferencesUtil.getPreferenceStore().getBoolean(term.getUuid().toString()));
                     areaPosition.put(term.getUuid(), columnIndex);
                     if (PreferencesUtil.isShowIdInVocabularyInChecklistEditor()){
                         if (term.getIdInVocabulary() != null){
@@ -414,7 +415,7 @@ public class ChecklistEditorE4 implements IPartContentHasFactualData, IConversat
                 }
             }
         }
-		return restoreColumnWidth;
+//		return restoreColumnWidth;
 	}
 
     /**