commit 575a6bd5700c8a1bee5ee3a701977f39ed7985ff
Author: Andreas Müller <a.mueller@bgbm.org>
Date:   Mon Oct 11 13:41:12 2021 +0200

    ref #9778 adapt redlist import to new existing ranks lusus and subproles

diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/io/redlist/gefaesspflanzen/RedListGefaesspflanzenImportNames.java b/app-import/src/main/java/eu/etaxonomy/cdm/io/redlist/gefaesspflanzen/RedListGefaesspflanzenImportNames.java
index 1dbd74a0..b177f68f 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/io/redlist/gefaesspflanzen/RedListGefaesspflanzenImportNames.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/io/redlist/gefaesspflanzen/RedListGefaesspflanzenImportNames.java
@@ -602,15 +602,9 @@ public class RedListGefaesspflanzenImportNames extends DbImportBase<RedListGefae
             else if(rankStr.equals("SAM")){
                 return getRank(state, RedListUtil.uuidRankCollectionSpecies, "Collective Species", "Collective Species", "\"Coll. Species\"", (OrderedTermVocabulary<Rank>) Rank.GENUS().getVocabulary(), null, RankClass.SpeciesGroup);
             }
-            else if(rankStr.equals("SPR")){
-                return getRank(state, RedListUtil.uuidRankSubproles, "Subproles", "Subproles", "subproles", (OrderedTermVocabulary<Rank>) Rank.GENUS().getVocabulary(), null, RankClass.Infraspecific);
-            }
             else if(rankStr.equals("MOD")){
                 return getRank(state, RedListUtil.uuidRankModification, "Modification", "Modification", "modificatio", (OrderedTermVocabulary<Rank>) Rank.GENUS().getVocabulary(), null, RankClass.Infraspecific);
             }
-            else if(rankStr.equals("LUS")){
-                return getRank(state, RedListUtil.uuidRankLusus, "Lusus", "Lusus", "lusus", (OrderedTermVocabulary<Rank>) Rank.GENUS().getVocabulary(), null, RankClass.Infraspecific);
-            }
             else if(rankStr.equals("SPI")){
                 return getRank(state, RedListUtil.uuidRankSubspeciesPrincipes, "Subspecies principes", "Subspecies principes", "subsp. princ.", (OrderedTermVocabulary<Rank>) Rank.GENUS().getVocabulary(), null, RankClass.Infraspecific);
             }
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/io/redlist/gefaesspflanzen/RedListGefaesspflanzenTransformer.java b/app-import/src/main/java/eu/etaxonomy/cdm/io/redlist/gefaesspflanzen/RedListGefaesspflanzenTransformer.java
index aeaea300..d084c996 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/io/redlist/gefaesspflanzen/RedListGefaesspflanzenTransformer.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/io/redlist/gefaesspflanzen/RedListGefaesspflanzenTransformer.java
@@ -53,6 +53,7 @@ public final class RedListGefaesspflanzenTransformer extends InputTransformerBas
         else if (key.equals("SVA")){return Rank.SUBVARIETY();}
         else if (key.equals("CV")){return Rank.CULTIVAR();}
         else if (key.equals("PRO")){return Rank.PROLES();}
+        else if (key.equals("SPR")){return Rank.SUBPROLES();}
         else if (key.equals("SER")){return Rank.SERIES();}
         else if (key.equals("GRE")){
             logger.warn("Unclear which grex is meant here");
@@ -60,6 +61,7 @@ public final class RedListGefaesspflanzenTransformer extends InputTransformerBas
         else if (key.equals("AGG")){return Rank.SPECIESAGGREGATE();}
         else if (key.equals("SFO")){return Rank.SUBFORM();}
         else if (key.equals("FAM")){return Rank.FAMILY();}
+        else if (key.equals("LUS")){return Rank.LUSUS();}
         else if (key.equals("SLU")){return Rank.SUBLUSUS();}
         else if (key.equals("SPI")){return Rank.SUBSPECIES();}
         else if (key.equals("GRO") || key.equals("GRU")){return Rank.SPECIESGROUP();}
diff --git a/app-import/src/main/java/eu/etaxonomy/cdm/io/redlist/gefaesspflanzen/RedListUtil.java b/app-import/src/main/java/eu/etaxonomy/cdm/io/redlist/gefaesspflanzen/RedListUtil.java
index bf268232..10ec19ea 100644
--- a/app-import/src/main/java/eu/etaxonomy/cdm/io/redlist/gefaesspflanzen/RedListUtil.java
+++ b/app-import/src/main/java/eu/etaxonomy/cdm/io/redlist/gefaesspflanzen/RedListUtil.java
@@ -45,9 +45,7 @@ public class RedListUtil {
     public static final UUID uuidClassificationS = UUID.fromString("53e81162-5c2d-425b-bbe6-6e8d12e85790");
 
     public static final UUID uuidRankCollectionSpecies = UUID.fromString("6056e143-4efe-4632-b532-27699ed62884");
-    public static final UUID uuidRankSubproles = UUID.fromString("47bd1439-c2ba-4c4e-994f-9c60853258f8");
     public static final UUID uuidRankModification = UUID.fromString("1c6e16f5-f7a5-41a5-9cc4-53c1438478c9");
-    public static final UUID uuidRankLusus = UUID.fromString("4c8e12f6-2c16-4eda-a7d9-2fd247dcce789");
     public static final UUID uuidRankSubspeciesPrincipes = UUID.fromString("b6b9351b-6beb-431d-8c7a-d30fe0cf3a90");
     public static final UUID uuidRankCombination = UUID.fromString("ec2c580e-416a-4ecf-85df-d03641f3bd64");
     public static final UUID uuidRankForme = UUID.fromString("05b4f66f-5559-4e44-bbb8-70744a5ea64a");