commit 9fe639a81327688268785a5704b91fd4b5918dc2
Author: Patrick Plitzner <p.plitzner@bgbm.org>
Date:   Mon Nov 14 09:26:43 2016 +0100

    ref #6131 Redirect for old URLs
    
     - deleted test ui class

diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/ui/CheckUI.java b/src/main/java/eu/etaxonomy/cdm/vaadin/ui/CheckUI.java
deleted file mode 100644
index d5381157..00000000
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/ui/CheckUI.java
+++ /dev/null
@@ -1,49 +0,0 @@
-package eu.etaxonomy.cdm.vaadin.ui;
-
-import javax.servlet.annotation.WebServlet;
-
-import com.vaadin.annotations.Theme;
-import com.vaadin.annotations.VaadinServletConfiguration;
-import com.vaadin.server.VaadinRequest;
-import com.vaadin.server.VaadinServlet;
-import com.vaadin.ui.Button;
-import com.vaadin.ui.Button.ClickEvent;
-import com.vaadin.ui.Label;
-import com.vaadin.ui.UI;
-import com.vaadin.ui.VerticalLayout;
-
-@Theme("valo")
-@SuppressWarnings("serial")
-public class CheckUI extends UI
-{
-
-//    @WebServlet(value = "/*", asyncSupported = true, initParams = {
-//			@WebInitParam(name="org.atmosphere.cpr.asyncSupport", value="org.atmosphere.container.Jetty9AsyncSupportWithWebSocket")
-//	})
-
-    /*
-     * NOTE: productionMode=true seems not to have any effect here, maybe because we are using multiple Servlets?
-     * The is therefore set globally in the web.xml
-     */
-    @WebServlet(value = {"/app/*"}, asyncSupported = true)
-    @VaadinServletConfiguration(productionMode = true, ui = CheckUI.class, widgetset = "eu.etaxonomy.cdm.vaadin.AppWidgetSet")
-    public static class Servlet extends VaadinServlet {
-    }
-
-    @Override
-    protected void init(VaadinRequest request) {
-        final VerticalLayout layout = new VerticalLayout();
-        layout.setMargin(true);
-        setContent(layout);
-
-        Button button = new Button("Click Me");
-        button.addClickListener(new Button.ClickListener() {
-            @Override
-            public void buttonClick(ClickEvent event) {
-                layout.addComponent(new Label("Thank you for clicking"));
-            }
-        });
-        layout.addComponent(button);
-    }
-
-}
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/ui/ConceptRelationshipUIRedirect.java b/src/main/java/eu/etaxonomy/cdm/vaadin/ui/ConceptRelationshipUIRedirect.java
new file mode 100644
index 00000000..2ea3a1b0
--- /dev/null
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/ui/ConceptRelationshipUIRedirect.java
@@ -0,0 +1,70 @@
+// $Id$
+/**
+* Copyright (C) 2015 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.vaadin.ui;
+
+
+import javax.servlet.annotation.WebServlet;
+
+import org.apache.log4j.Logger;
+
+import com.vaadin.annotations.Theme;
+import com.vaadin.annotations.VaadinServletConfiguration;
+import com.vaadin.navigator.Navigator;
+import com.vaadin.server.VaadinRequest;
+import com.vaadin.server.VaadinServlet;
+import com.vaadin.ui.UI;
+
+import eu.etaxonomy.cdm.vaadin.view.ConceptRelationshipView;
+
+/**
+ * @author cmathew
+ * @date 9 Apr 2015
+ *
+ */
+@Theme("edit")
+public class ConceptRelationshipUIRedirect extends AbstractAuthenticatedUI {
+
+    Navigator navigator;
+
+    private static final String FIRST_VIEW = "editcr";
+
+    private final static Logger logger = Logger.getLogger(ConceptRelationshipUIRedirect.class);
+
+    /*
+     * NOTE: productionMode=true seems not to have any effect here, maybe because we are using multiple Servlets?
+     * The is therefore set globally in the web.xml
+     */
+    @WebServlet(value = {"/app/editcr/*"}, asyncSupported = true)
+    @VaadinServletConfiguration(productionMode = true, ui = ConceptRelationshipUIRedirect.class, widgetset = "eu.etaxonomy.cdm.vaadin.AppWidgetSet")
+    public static class Servlet extends VaadinServlet {
+    }
+
+    @Override
+    protected void doInit(VaadinRequest request) {
+        // FIXME: remove this when testing is done
+        //setIgnoreAuthentication(true);
+
+        getPage().setTitle("Concept Relationship Editor");
+        logger.warn("original classification : " + request.getParameter("oc"));
+        logger.warn("copy classification : " + request.getParameter("cc"));
+        String oc = request.getParameter("oc");
+        String cc = request.getParameter("cc");
+
+        ConceptRelationshipView crEditor = new ConceptRelationshipView(oc,cc);
+        UI.getCurrent().getNavigator().addView(FIRST_VIEW, crEditor);
+
+    }
+
+    @Override
+    public String getFirstViewName() {
+        return FIRST_VIEW;
+    }
+
+}
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/ui/DbStatusUIRedirect.java b/src/main/java/eu/etaxonomy/cdm/vaadin/ui/DbStatusUIRedirect.java
new file mode 100644
index 00000000..be178dbb
--- /dev/null
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/ui/DbStatusUIRedirect.java
@@ -0,0 +1,44 @@
+package eu.etaxonomy.cdm.vaadin.ui;
+
+import javax.servlet.annotation.WebServlet;
+
+import com.vaadin.annotations.Theme;
+import com.vaadin.annotations.Title;
+import com.vaadin.annotations.VaadinServletConfiguration;
+import com.vaadin.navigator.Navigator;
+import com.vaadin.server.VaadinRequest;
+import com.vaadin.ui.UI;
+
+import eu.etaxonomy.cdm.vaadin.servlet.CdmVaadinConversationalServlet;
+import eu.etaxonomy.cdm.vaadin.view.dbstatus.RedirectAfterLoginView;
+
+@Theme("macosx")
+@Title("CDM Board")
+@SuppressWarnings("serial")
+public class DbStatusUIRedirect extends AbstractAuthenticatedUI{
+
+	private static final String FIRST_VIEW = "firstView";
+
+    /*
+     * NOTE: productionMode=true seems not to have any effect here, maybe because we are using multiple Servlets?
+     * The is therefore set globally in the web.xml
+     */
+	@WebServlet(value = {"/app/dbstatus/*"}, asyncSupported = true)
+	@VaadinServletConfiguration(productionMode = true, ui = DbStatusUIRedirect.class, widgetset = "eu.etaxonomy.cdm.vaadin.AppWidgetSet")
+	public static class Servlet extends CdmVaadinConversationalServlet {
+	}
+
+
+	@Override
+	protected void doInit(VaadinRequest request) {
+		Navigator navigator = UI.getCurrent().getNavigator();
+		RedirectAfterLoginView view = new RedirectAfterLoginView();
+		navigator.addView(getFirstViewName(), view);
+	}
+
+	@Override
+	public String getFirstViewName() {
+		return FIRST_VIEW;
+	}
+
+}